# <pvcsaddfiles>

Adds files to a PVCS repository.

This task uses the `addfiles` PCLI command to add files to a PVCS repository.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
archivedescription | string | Gets or sets the archive description for versioned files. | True
copymode | PVCSCopyMode | Gets or sets the copy mode for the operation. | False
deleteworkfiles | bool | Gets or sets a value indicating whether workfiles will be deleted after adding them to PVCS. | False
description | string | Gets or sets the description for versioned files. | False
lock | bool | Gets or sets a value indicating whether versioned files should be locked after being added to PVCS. | False
promotiongroup | string | Gets or sets the promotion group to which added files will be assigned. Setting this attribute to an empty string indicates the versioned files will not be assigned to any promotion group. | False
suppressaddifexists | bool | Gets or sets a value indicating whether workfiles shouldn't be added if they already exist in the PVCS repository. | False
versionlabel | string | Gets or sets the version label to assign to the added versioned files. | False
projectdatabase | string | Gets or sets the project database to utilize during the operation. | True
failonerror | bool | Determines if task failure stops the build, or is just reported. The default is true. | False
if | bool | If true then the task will be executed; otherwise, skipped. The default is true. | False
includesubprojects | bool | Gets or sets a value indicating whether the operation should include subprojects. | False
password | string | Gets or sets the password to use when connecting to the project database. | False
projectpath | string | Gets or sets the project path to utilize during the operation. | False
pvcsbin | string | Gets or sets the location of the PVCS binary command-line tools. | False
timeout | int | The maximum amount of time the application is allowed to execute, expressed in milliseconds. Defaults to no time-out. | False
unless | bool | Opposite of `if`. If false then the task will be executed; otherwise, skipped. The default is false. | False
userid | string | Gets or sets the user ID to use when connecting to the project database. | False
verbose | bool | Determines whether the task should report detailed build log messages. The default is false. | False
workspace | string | Gets or sets the workspace to use when connecting to the project database. | False

### Framework-configurable parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
useruntimeengine | bool | Specifies whether the external program should be executed using a runtime engine, if configured. The default is false. | False

### Nested Elements:

#### <entities>

Gets or sets the entities involved in the operation.

#### </entities>

#### <arg>

The command-line arguments for the external program.

Represents a command-line argument.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
dir | directory | The value for a directory-based command-line argument; will be replaced with the absolute path of the directory. | False
file | file | The name of a file as a single command-line argument; will be replaced with the absolute filename of the file. | False
if | bool | Indicates if the argument should be passed to the external program. If true then the argument will be passed; otherwise, skipped. The default is true. | False
line | string | List of command-line arguments; will be passed to the executable as is. | False
path | <path> | The value for a PATH-like command-line argument; you can use `:` or `;` as path separators and NAnt will convert it to the platform's local conventions, while resolving references to environment variables. | False
unless | bool | Indicates if the argument should not be passed to the external program. If false then the argument will be passed; otherwise, skipped. The default is false. | False
value | string | A single command-line argument; can contain space characters. | False

### Nested Elements:

#### <path>

Sets a single command-line argument and treats it like a PATH - ensures the right separator for the local platform is used.

#### </path>

### Examples

- A single command-line argument containing a space character.

      <arg value="-l -a" />

- Two separate command-line arguments.

      <arg line="-l -a" />

- A single command-line argument with the value `\dir;\dir2;\dir3` on DOS-based systems and `/dir:/dir2:/dir3` on Unix-like systems.

      <arg path="/dir;/dir2:\dir3" />

#### </arg>

### Examples

- Adds `File1.txt` and `File2.txt` to the root level of the project database specified by the `project-database` property.

      <pvcsaddfiles projectdatabase="${project-database}" archivedescription="Adding files to source control.">
          <entities>
              <entity name="C:\Data\File1.txt"/>
              <entity name="C:\Data\Folder\File2.txt"/>
          </entities>
      </pvcsaddfiles>

- Adds `File1.txt` and `File2.txt` to the `folder` project of the project database specified by the `project-database` property.

      <pvcsaddfiles projectdatabase="${project-database}" archivedescription="Adding files to source control." projectpath="/folder">
          <entities>
              <entity name="C:\Data\File1.txt"/>
              <entity name="C:\Data\Folder\File2.txt"/>
          </entities>
      </pvcsaddfiles>

- Adds `another_file.txt` and all files and folders at and below `C:\Data` to the project database specified by the `project-database` property.

      <pvcsaddfiles projectdatabase="${project-database}" archivedescription="Adding files to source control." includesubprojects="true">
          <entities>
              <entity name="C:\Data\"/>
              <entity name="C:\Temp\another_file.txt"/>
          </entities>
      </pvcsaddfiles>

- Adds all files at and below `C:\Data\` to the project database specified by the `project-database` property. Workfiles will be copied to the workfile location and will overwrite any existing files (as dictated by the `copymode` attribute). The relevant revisions will be locked in PVCS. Added files will be assigned the `SYSTEST` promotion group.

      <pvcsaddfiles projectdatabase="${project-database}" archivedescription="Files." copymode="CopyWorkfileWithOverwrite" lock="true" promotiongroup="SYSTEST" includesubprojects="true">
          <entities>
              <entity name="C:\Data\"/>
          </entities>
      </pvcsaddfiles>

### Requirements

Assembly: NAnt.Contrib.Tasks (0.85.2479.0)